function frmMainLoaded()
    tinsert(UISpecialFrames,"frmMain");
    frmMain:RegisterForDrag("LeftButton");
	-- Version Print
	if(oldversion==nil) then oldversion="1"; end -- Fix a bug when comparing to oldversion=nil
	vers = GetAddOnMetadata("ELGoH", "X-Curse-Packaged-Version") 
	vers = string.sub(vers, 1);
	if(vers>oldversion or playername=="Taurast") then
		RunOnce();
		print("Welcome to ELGoH "..vers..".\nType /elgoh info for a list of commands.");
		oldversion=vers;
	end
	-- End Version Print
	--Set the Legend Buttons
	btnHatfield:SetText(legend);
	edtLegend:SetText(legend);
	edtLegend_Short:SetText(legend_short);
	acceptReply=false;
	replies=0;
	incoming=0;
	pA=0;
end

function RunOnce()
	if(GetNumGuildMembers(1)==0) then
		print("An error has occurred, you are not in a guild?");
	else
		for i = 1, GetNumGuildMembers(0), 1 do 
			name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
			if(name==UnitName("player")) then
			-- Setting up the Saved Variables
				playername, playerrealm=UnitName("player");
				playerrank=rankIndex;
				playerguild=GetGuildInfo("player");
				legend="Taurast";
				legend_short="Taur";
				break;
			end
		end
	end
end

function BreakTimer()
SendChatMessage("Go have a break guys, but be back in 10 minutes", "RAID")
DBM:CreatePizzaTimer(600, "Breaktime", 1, "The Officers")
end

function lgohInfo()
	print("|cFF00FF00Welcome to the LGoH addon! If you find anything that doesn't work (or does work), or something you feel could do with a little tweaking feel free to message me in game :)\n");
	print("|cFF00FF00If a box is left blank, it will apply to yourself, or your target if you have one");
	print("|cFF00FF00Shift Clicking the top button in the Fun Panel will allow you to change the legendary character in the Legend Facts database (a few of them will have bad grammar)");
	print("|cFF8888FFAvailable commands:\n/elgoh\n/elgoh info\n/elgoh officer\n/elgoh startdkp - generates a start bonus string for GuildLaunch\n/elgoh clean - Cleans members offline for more than 29 days");

end

function possessTarget()
if(UnitName("target")~=nil) then
	if(pA==0) then
		print("You must type \"/anoo possess-allow\" to enable this feature. Warning, you will be vulnerable to possessions as well");
	else
		SendAddonMessage("lgoh", edtPTarget:GetText(), "WHISPER", UnitName("target"));
	end
else
	print("No Target");
end
end

function flaskCheck()
	--SendAddonMessage("lgohBuff", "flask?", "RAID");
	--acceptReply=true;
	if(devel==1) then 
		fntFlask:SetText("You are Taurast!");
		FlaskFrame:Show();
	end
	i=0;
	flasked=0;
	buffName = UnitBuff("player", 1);
	for n=0, GetNumRaidMembers(), 1 do
		while buffName do
			i = i + 1;
			buffName = UnitBuff("raid"..n, i)
			if(buffName~=nil and buffName~="") then
				if(string.find(buffName, "Flask")) then
					if(string.find(buffName, "Enhancement") or string.find(buffName, "North")) then
						print(UnitName("raid"..n).." has an innappropriate flask!");
						flasked=1;
						return 1;
					end
				end
			end
		end
		if(flasked==0) then
			UnitName("raid"..n.." has no flask")
		end
	end
end

function possessed(event, ...)
if(event=="CHAT_MSG_ADDON") then
	local prefix, msg, how, who = select(1, ...);
	if(prefix=="lgoh") then
		print(who.." possessed you...");
		if(GetNumRaidMembers()>0) then
			SendChatMessage(msg, RAID);
		elseif(GetNumPartyMembers()>0) then
			SendChatMessage(msg, PARTY);
		else
			SendChatMessage(msg, SAY);
		end
	end
	if(prefix=="lgohBuff") then
		i=0;
		flasked=0;
		buffName = UnitBuff("player", 1);
		while buffName do
			i = i + 1;
			buffName = UnitBuff("player", i)
			if(buffName~=nil and buffName~="") then
				if(string.find(buffName, "Flask")) then
					if(string.find(buffName, "Enhancement") or string.find(buffName, "North")) then
						fntFlask:SetText("You have an innappropriate flask!");
						FlaskFrame:Show();
						flasked=1;
						SendAddonMessage("BuffReply", UnitName("player").." has a bad flask", "RAID");
						break
					else
						print("Be sure to check the time left on your "..buffName..".");
						flasked=1;
						break
					end
				end
			end
		end
		if(flasked==0) then
			fntFlask:SetText("You have no flask!");
			FlaskFrame:Show();
			SendAddonMessage("BuffReply", UnitName("player").." has no flask", "RAID");
		end
	end
	if(prefix=="BuffReply") then
		if(acceptReply==true and replies<=(GetNumRaidMembers()+1)) then
			print(msg);
			replies = replies + 1
		else
			acceptReply=false;
			replies=0;
		end
	end
end
if(event=="PARTY_LOOT_METHOD_CHANGED") then
	lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod();
	if(lootmethod=="master") then
		if(masterlooterRaidID) then
			name = GetRaidRosterInfo(masterlooterRaidID);
		elseif(masterlooterPartyID) then
			name = GetRaidRosterInfo(masterlooterPartyID);
		end
		if(name~=nil and name~="") then
		edtMaster:SetText("Master Looter: "..name);
		end
	end
end
end

function onIRUpdate()
	if(chkGrabbing:GetChecked()==1 and GetGuildRosterSelection()~=nil) then
		if(raidmember~=GetGuildRosterSelection()) then
			raidmember=GetGuildRosterSelection();
			if(i==nil) then i=0; end
			i=i+1;
			if(i>9) then i=1; end
			IR = {IR1, IR2, IR3, IR4, IR5, IR6, IR7, IR8, IR9}
			IR[i]:SetText(GetGuildRosterInfo(GetGuildRosterSelection()));
			IR[i+1]:SetText("...");
		end
	end
end

function Rottgut()
for i = 1, GetNumGuildMembers(1), 1 do 
	yearsOffline, monthsOffline, daysOffline, hoursOffline = GetGuildRosterLastOnline(i);
	name, rank, rankIndex, level, class, zone, note, officernote, online = GetGuildRosterInfo(i);
	if((online~=1 and (daysOffline>=29 or monthsOffline>0) and officernote~="NoKick") or (online~=1 and (daysOffline>=20 and rankIndex==7) and level<=50)) then 
		print("Kick "..name)
		GuildUninvite(name);
	end
end
end

SLASH_LGOH1 = "/lgoh"
SlashCmdList["LGOH"] = function(msg, editBox)
    if(msg=="officer" or msg=="o") then
		if (playerrank==0 or playerrank==1 or playerrank==2) then
			frmOfficer:Show();
		else
			print("You are not ranked high enough at "..playerrank..", requires 0 or 1");
		end
    elseif(msg=="rottgut" or msg=="clean") then
		if (playerrank==0 or playerrank==1) then
			Rottgut();
		else
			print("You are not ranked high enough at "..playerrank..", requires 0 or 1");
		end
	elseif(msg=="info") then
		lgohInfo()
	elseif(msg=="startdkp") then
		StartDKP()
	else
		frmMain:Show();
    end
end

SLASH_ELGOH1 = "/elgoh"
SlashCmdList["ELGOH"] = function(msg, editBox)
    if(msg=="officer" or msg=="o") then
		if (playerrank==0 or playerrank==1) then
			frmOfficer:Show();
		else
			print("You are not ranked high enough at "..playerrank..", requires 9+");
		end
	elseif(msg=="clean") then
		if (playerrank==0 or playerrank==1) then
			Rottgut();
		else
			print("You are not ranked high enough at "..playerrank..", requires 0 or 1");
		end
	elseif(msg=="info") then
		lgohInfo()
	elseif(msg=="startdkp") then
		StartDKP()
	else
		frmMain:Show();
    end
end

SLASH_ANOO1 = "/anoo"
SlashCmdList["ANOO"] = function(msg, editBox)
    --SendChatMessage("herps.", "EMOTE");
	if(msg=="dev") then
		devel=1;
	elseif(msg=="possess-allow") then
		pA=1;
		print("Allowing Possessions");
	elseif(msg=="possess-disable") then
		pA=0;
		print("Disabling Possessions");
	else
		ReloadUI();
	end
end

function SetMaster()
if(edtMaster:GetText()=="Not Set" or edtMaster:GetText()=="") then 
	edtMaster:SetText("Not Set");
	if(UnitName("target")==nil) then 
		SetLootMethod("master", UnitName("player"));
		edtMaster:ClearFocus();
	else
		SetLootMethod("master", UnitName("target"));
		edtMaster:ClearFocus();
	end
else
	SetLootMethod("master", edtMaster:GetText());
	edtMaster:ClearFocus();
end
end

function Blame()
	if(edtBlame:GetText()=="" or edtBlame:GetText()==nil) then
		if(btnRaid:GetChecked()==1 and GetNumRaidMembers()) then
			i = random(1,GetNumRaidMembers());
			name = GetRaidRosterInfo(i);
			PostTo("I blame " ..name.. ".");
		elseif (btnGuild:GetChecked()) then
			guildies=GetNumGuildMembers(false);
			i = math.random(1, guildies); 
			name, rank, rankIndex, level, class, zone, note, officernote, online = GetGuildRosterInfo(i);
			if(online) then 
				PostTo("I blame " ..name.. ".") 
			else
				Blame();
			end
		end
	else
		PostTo("I blame " ..edtBlame:GetText().. ".");
	end
	edtBlame:ClearFocus();
end

function PostTo(str)
if (btnGuild:GetChecked()) then SendChatMessage(str, "GUILD") end
if (btnRaid:GetChecked()) then SendChatMessage(str, "RAID") end
if (btnSay:GetChecked()) then SendChatMessage(str, "SAY") end
if (btnParty:GetChecked()) then SendChatMessage(str, "PARTY") end
if (btnGuild:GetChecked()==nil and btnRaid:GetChecked()==nil and btnParty:GetChecked()==nil and btnSay:GetChecked()==nil) then print(str); end
end

function RandomJoke()
	local RANDOM_JOKES = { 
			"Can atheists get insurance for acts of God?",
			"Does the name Pavlov ring a bell? ",
			"Do illiterate people get the full effect of alphabet soup? ",
			"If love is blind, is lingerie considered Braille? ",
			"Is it true that cannibals don't eat clowns because they taste funny?  ",
			"What would the world be like without hypothetical situations?",
			"Owners of digital watches: Your day's are numbered!  ",
			"A printer consists of three main parts: the case, the jammed paper tray and the blinking red light. ",
			"A user friendly computer first requires a friendly user. ",
			"There are only 10 types of people in this world: those who understand binary, those who don't and those who are tired of this joke. ",
			"Who puts the thin ice sign in the middle of the thin ice? "};	
	local index = random(1, #RANDOM_JOKES);
	local str = RANDOM_JOKES[index];
	PostTo(str);
end

function RandomFact()
	local ALL_FACTS = {
					"Odontophobia is the fear of teeth. ",
					"The 57 on Heinz ketchup bottles represents the number of varieties of pickles the company once had. ",
					"The surface area of an average-sized brick is 79 cm squared.  ",
					"According to suicide statistics, Monday is the favored day for self-destruction. ",
					"Cats can sleep 16 to 18 hours per day. ",
					"Karaoke means empty orchestra in Japanese.  ",
					"The first known contraceptive was crocodile dung, used by Egyptians in 2000 B.C. ",
					"The most money ever paid for a cow in an auction was $1.3 million.  ",
					"The Neanderthal's brain was bigger than yours is. ",
					"The sound of E.T. walking was made by someone squishing her hands in jelly. ",
					"There are 10 human body parts that are only 3 letters long (eye hip arm leg ear toe jaw rib lip gum). ",
					"The king of hearts is the only king without a moustache.  ",
					"The word lethologica describes the state of not being able to remember the word you want. ",
					"In the average lifetime, a person will walk the equivalent of 5 times around the equator. " };
	local index = random(1, #ALL_FACTS);
	local str = ALL_FACTS[index];
	PostTo(str);
end